!
!   ARMPL version 21.0 Copyright ARM, NAG 2021
!
!   Interface blocks for Fortran BLAS routines in ARMPL
!
  Module armpl_blas
! .. Interface Blocks ..
      Interface
        Subroutine caxpy(n, ca, cx, incx, cy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: ca
          Integer :: incx, incy, n
! .. Array Arguments ..
          Complex (wp) :: cx(*), cy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine caxpy
        Subroutine ccopy(n, cx, incx, cy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, incy, n
! .. Array Arguments ..
          Complex (wp) :: cx(*), cy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ccopy
        Function cdotc(n, cx, incx, cy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, incy, n
! .. Array Arguments ..
          Complex (wp) :: cx(*), cy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
! .. Function Return Value ..
          Complex (wp) :: cdotc
        End Function cdotc
        Function cdotu(n, cx, incx, cy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, incy, n
! .. Array Arguments ..
          Complex (wp) :: cx(*), cy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
! .. Function Return Value ..
          Complex (wp) :: cdotu
        End Function cdotu
        Subroutine cgbmv(trans, m, n, kl, ku, alpha, a, lda, x, incx, beta, y, &
          incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: incx, incy, kl, ku, lda, m, n
          Character (1) :: trans
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine cgbmv
        Subroutine cgemm(transa, transb, m, n, k, alpha, a, lda, b, ldb, beta, &
          c, ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: k, lda, ldb, ldc, m, n
          Character (1) :: transa, transb
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), b(ldb, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine cgemm
        Subroutine cgemmt(uplo, transa, transb, n, k, alpha, a, lda, b, ldb, beta, &
          c, ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: n, k, lda, ldb, ldc
          Character (1) :: uplo, transa, transb
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), b(ldb, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine cgemmt
        Subroutine cgemv(trans, m, n, alpha, a, lda, x, incx, beta, y, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: incx, incy, lda, m, n
          Character (1) :: trans
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine cgemv
        Subroutine cgerbc(m, n, alpha, x, incx, y, incy, beta, a, lda)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: incx, incy, lda, m, n
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine cgerbc
        Subroutine cgerbu(m, n, alpha, x, incx, y, incy, beta, a, lda)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: incx, incy, lda, m, n
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine cgerbu
        Subroutine cgerc(m, n, alpha, x, incx, y, incy, a, lda)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha
          Integer :: incx, incy, lda, m, n
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine cgerc
        Subroutine cgeru(m, n, alpha, x, incx, y, incy, a, lda)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha
          Integer :: incx, incy, lda, m, n
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine cgeru
        Subroutine chbmv(uplo, n, k, alpha, a, lda, x, incx, beta, y, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: incx, incy, k, lda, n
          Character (1) :: uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine chbmv
        Subroutine chemm(side, uplo, m, n, alpha, a, lda, b, ldb, beta, c, &
          ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: lda, ldb, ldc, m, n
          Character (1) :: side, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), b(ldb, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine chemm
        Subroutine chemv(uplo, n, alpha, a, lda, x, incx, beta, y, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: incx, incy, lda, n
          Character (1) :: uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine chemv
        Subroutine cher(uplo, n, alpha, x, incx, a, lda)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: alpha
          Integer :: incx, lda, n
          Character (1) :: uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine cher
        Subroutine cher2(uplo, n, alpha, x, incx, y, incy, a, lda)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha
          Integer :: incx, incy, lda, n
          Character (1) :: uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine cher2
        Subroutine cher2k(uplo, trans, n, k, alpha, a, lda, b, ldb, beta, c, &
          ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha
          Real (wp) :: beta
          Integer :: k, lda, ldb, ldc, n
          Character (1) :: trans, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), b(ldb, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine cher2k
        Subroutine cherk(uplo, trans, n, k, alpha, a, lda, beta, c, ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: k, lda, ldc, n
          Character (1) :: trans, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine cherk
        Subroutine chpmv(uplo, n, alpha, ap, x, incx, beta, y, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: incx, incy, n
          Character (1) :: uplo
! .. Array Arguments ..
          Complex (wp) :: ap(*), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine chpmv
        Subroutine chpr(uplo, n, alpha, x, incx, ap)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: alpha
          Integer :: incx, n
          Character (1) :: uplo
! .. Array Arguments ..
          Complex (wp) :: ap(*), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine chpr
        Subroutine chpr2(uplo, n, alpha, x, incx, y, incy, ap)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha
          Integer :: incx, incy, n
          Character (1) :: uplo
! .. Array Arguments ..
          Complex (wp) :: ap(*), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine chpr2
        Subroutine crotg(ca, cb, c, s)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: ca, cb, s
          Real (wp) :: c
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine crotg
        Subroutine cscal(n, ca, cx, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: ca
          Integer :: incx, n
! .. Array Arguments ..
          Complex (wp) :: cx(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine cscal
        Subroutine csrot(n, cx, incx, cy, incy, c, s)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: c, s
          Integer :: incx, incy, n
! .. Array Arguments ..
          Complex (wp) :: cx(*), cy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine csrot
        Subroutine csscal(n, sa, cx, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: sa
          Integer :: incx, n
! .. Array Arguments ..
          Complex (wp) :: cx(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine csscal
        Subroutine cswap(n, cx, incx, cy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, incy, n
! .. Array Arguments ..
          Complex (wp) :: cx(*), cy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine cswap
        Subroutine csymm(side, uplo, m, n, alpha, a, lda, b, ldb, beta, c, &
          ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: lda, ldb, ldc, m, n
          Character (1) :: side, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), b(ldb, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine csymm
        Subroutine csyr2k(uplo, trans, n, k, alpha, a, lda, b, ldb, beta, c, &
          ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: k, lda, ldb, ldc, n
          Character (1) :: trans, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), b(ldb, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine csyr2k
        Subroutine csyrk(uplo, trans, n, k, alpha, a, lda, beta, c, ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: k, lda, ldc, n
          Character (1) :: trans, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine csyrk
        Subroutine ctbmv(uplo, trans, diag, n, k, a, lda, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, k, lda, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ctbmv
        Subroutine ctbsv(uplo, trans, diag, n, k, a, lda, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, k, lda, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ctbsv
        Subroutine ctpmv(uplo, trans, diag, n, ap, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Complex (wp) :: ap(*), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ctpmv
        Subroutine ctpsv(uplo, trans, diag, n, ap, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Complex (wp) :: ap(*), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ctpsv
        Subroutine ctrmm(side, uplo, transa, diag, m, n, alpha, a, lda, b, &
          ldb)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha
          Integer :: lda, ldb, m, n
          Character (1) :: diag, side, transa, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), b(ldb, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ctrmm
        Subroutine ctrmv(uplo, trans, diag, n, a, lda, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, lda, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ctrmv
        Subroutine ctrsm(side, uplo, transa, diag, m, n, alpha, a, lda, b, &
          ldb)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha
          Integer :: lda, ldb, m, n
          Character (1) :: diag, side, transa, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), b(ldb, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ctrsm
        Subroutine ctrsv(uplo, trans, diag, n, a, lda, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, lda, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ctrsv
        Function dasum(n, dx, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, n
! .. Array Arguments ..
          Real (wp) :: dx(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
! .. Function Return Value ..
          Real (wp) :: dasum
        End Function dasum
        Subroutine daxpy(n, da, dx, incx, dy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: da
          Integer :: incx, incy, n
! .. Array Arguments ..
          Real (wp) :: dx(*), dy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine daxpy
        Function dcabs1(z)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: z
! .. Intrinsic Procedures ..
          Intrinsic :: kind
! .. Function Return Value ..
          Real (wp) :: dcabs1
        End Function dcabs1
        Subroutine dcopy(n, dx, incx, dy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, incy, n
! .. Array Arguments ..
          Real (wp) :: dx(*), dy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dcopy
        Function ddot(n, dx, incx, dy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, incy, n
! .. Array Arguments ..
          Real (wp) :: dx(*), dy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
! .. Function Return Value ..
          Real (wp) :: ddot
        End Function ddot
        Subroutine dgbmv(trans, m, n, kl, ku, alpha, a, lda, x, incx, beta, y, &
          incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: incx, incy, kl, ku, lda, m, n
          Character (1) :: trans
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dgbmv
        Subroutine dgemm(transa, transb, m, n, k, alpha, a, lda, b, ldb, beta, &
          c, ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: k, lda, ldb, ldc, m, n
          Character (1) :: transa, transb
! .. Array Arguments ..
          Real (wp) :: a(lda, *), b(ldb, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dgemm
        Subroutine dgemmt(uplo, transa, transb, n, k, alpha, a, lda, b, ldb, beta, &
          c, ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: n, k, lda, ldb, ldc
          Character (1) :: uplo, transa, transb
! .. Array Arguments ..
          Real (wp) :: a(lda, *), b(ldb, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dgemmt
        Subroutine dgemv(trans, m, n, alpha, a, lda, x, incx, beta, y, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: incx, incy, lda, m, n
          Character (1) :: trans
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dgemv
        Subroutine dger(m, n, alpha, x, incx, y, incy, a, lda)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: alpha
          Integer :: incx, incy, lda, m, n
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dger
        Subroutine dgerb(m, n, alpha, x, incx, y, incy, beta, a, lda)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: incx, incy, lda, m, n
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dgerb
        Function dnrm2(n, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, n
! .. Array Arguments ..
          Real (wp) :: x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
! .. Function Return Value ..
          Real (wp) :: dnrm2
        End Function dnrm2
        Subroutine drot(n, dx, incx, dy, incy, c, s)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: c, s
          Integer :: incx, incy, n
! .. Array Arguments ..
          Real (wp) :: dx(*), dy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine drot
        Subroutine drotg(da, db, c, s)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: c, da, db, s
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine drotg
        Subroutine drotm(n, dx, incx, dy, incy, dparam)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, incy, n
! .. Array Arguments ..
          Real (wp) :: dparam(5), dx(*), dy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine drotm
        Subroutine drotmg(dd1, dd2, dx1, dy1, dparam)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: dd1, dd2, dx1, dy1
! .. Array Arguments ..
          Real (wp) :: dparam(5)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine drotmg
        Subroutine dsbmv(uplo, n, k, alpha, a, lda, x, incx, beta, y, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: incx, incy, k, lda, n
          Character (1) :: uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dsbmv
        Subroutine dscal(n, da, dx, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: da
          Integer :: incx, n
! .. Array Arguments ..
          Real (wp) :: dx(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dscal
        Function dsdot(n, sx, incx, sy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, incy, n
! .. Array Arguments ..
          Real (wp) :: sx(*), sy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
! .. Function Return Value ..
          Real (wp) :: dsdot
        End Function dsdot
        Subroutine dspmv(uplo, n, alpha, ap, x, incx, beta, y, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: incx, incy, n
          Character (1) :: uplo
! .. Array Arguments ..
          Real (wp) :: ap(*), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dspmv
        Subroutine dspr(uplo, n, alpha, x, incx, ap)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: alpha
          Integer :: incx, n
          Character (1) :: uplo
! .. Array Arguments ..
          Real (wp) :: ap(*), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dspr
        Subroutine dspr2(uplo, n, alpha, x, incx, y, incy, ap)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: alpha
          Integer :: incx, incy, n
          Character (1) :: uplo
! .. Array Arguments ..
          Real (wp) :: ap(*), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dspr2
        Subroutine dswap(n, dx, incx, dy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, incy, n
! .. Array Arguments ..
          Real (wp) :: dx(*), dy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dswap
        Subroutine dsymm(side, uplo, m, n, alpha, a, lda, b, ldb, beta, c, &
          ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: lda, ldb, ldc, m, n
          Character (1) :: side, uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), b(ldb, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dsymm
        Subroutine dsymv(uplo, n, alpha, a, lda, x, incx, beta, y, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: incx, incy, lda, n
          Character (1) :: uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dsymv
        Subroutine dsyr(uplo, n, alpha, x, incx, a, lda)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: alpha
          Integer :: incx, lda, n
          Character (1) :: uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dsyr
        Subroutine dsyr2(uplo, n, alpha, x, incx, y, incy, a, lda)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: alpha
          Integer :: incx, incy, lda, n
          Character (1) :: uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dsyr2
        Subroutine dsyr2k(uplo, trans, n, k, alpha, a, lda, b, ldb, beta, c, &
          ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: k, lda, ldb, ldc, n
          Character (1) :: trans, uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), b(ldb, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dsyr2k
        Subroutine dsyrk(uplo, trans, n, k, alpha, a, lda, beta, c, ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: k, lda, ldc, n
          Character (1) :: trans, uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dsyrk
        Subroutine dtbmv(uplo, trans, diag, n, k, a, lda, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, k, lda, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dtbmv
        Subroutine dtbsv(uplo, trans, diag, n, k, a, lda, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, k, lda, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dtbsv
        Subroutine dtpmv(uplo, trans, diag, n, ap, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Real (wp) :: ap(*), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dtpmv
        Subroutine dtpsv(uplo, trans, diag, n, ap, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Real (wp) :: ap(*), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dtpsv
        Subroutine dtrmm(side, uplo, transa, diag, m, n, alpha, a, lda, b, &
          ldb)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: alpha
          Integer :: lda, ldb, m, n
          Character (1) :: diag, side, transa, uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), b(ldb, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dtrmm
        Subroutine dtrmv(uplo, trans, diag, n, a, lda, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, lda, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dtrmv
        Subroutine dtrsm(side, uplo, transa, diag, m, n, alpha, a, lda, b, &
          ldb)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: alpha
          Integer :: lda, ldb, m, n
          Character (1) :: diag, side, transa, uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), b(ldb, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dtrsm
        Subroutine dtrsv(uplo, trans, diag, n, a, lda, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, lda, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dtrsv
        Function dzasum(n, zx, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, n
! .. Array Arguments ..
          Complex (wp) :: zx(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
! .. Function Return Value ..
          Real (wp) :: dzasum
        End Function dzasum
        Function dznrm2(n, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, n
! .. Array Arguments ..
          Complex (wp) :: x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
! .. Function Return Value ..
          Real (wp) :: dznrm2
        End Function dznrm2
        Function icamax(n, cx, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Function Return Value ..
          Integer :: icamax
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, n
! .. Array Arguments ..
          Complex (wp) :: cx(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Function icamax
        Function idamax(n, dx, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Function Return Value ..
          Integer :: idamax
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, n
! .. Array Arguments ..
          Real (wp) :: dx(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Function idamax
        Function isamax(n, sx, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Function Return Value ..
          Integer :: isamax
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, n
! .. Array Arguments ..
          Real (wp) :: sx(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Function isamax
        Function izamax(n, zx, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Function Return Value ..
          Integer :: izamax
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, n
! .. Array Arguments ..
          Complex (wp) :: zx(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Function izamax
        Function lsame(ca, cb)
! .. Implicit None Statement ..
          Implicit None
! .. Function Return Value ..
          Logical :: lsame
! .. Scalar Arguments ..
          Character (1) :: ca, cb
        End Function lsame
        Function sasum(n, sx, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, n
! .. Array Arguments ..
          Real (wp) :: sx(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
! .. Function Return Value ..
          Real (wp) :: sasum
        End Function sasum
        Subroutine saxpy(n, sa, sx, incx, sy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: sa
          Integer :: incx, incy, n
! .. Array Arguments ..
          Real (wp) :: sx(*), sy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine saxpy
        Function scabs1(z)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: z
! .. Intrinsic Procedures ..
          Intrinsic :: kind
! .. Function Return Value ..
          Real (wp) :: scabs1
        End Function scabs1
        Function scasum(n, cx, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, n
! .. Array Arguments ..
          Complex (wp) :: cx(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
! .. Function Return Value ..
          Real (wp) :: scasum
        End Function scasum
        Function scnrm2(n, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, n
! .. Array Arguments ..
          Complex (wp) :: x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
! .. Function Return Value ..
          Real (wp) :: scnrm2
        End Function scnrm2
        Subroutine scopy(n, sx, incx, sy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, incy, n
! .. Array Arguments ..
          Real (wp) :: sx(*), sy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine scopy
        Function sdot(n, sx, incx, sy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, incy, n
! .. Array Arguments ..
          Real (wp) :: sx(*), sy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
! .. Function Return Value ..
          Real (wp) :: sdot
        End Function sdot
        Function sdsdot(n, sb, sx, incx, sy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: sb
          Integer :: incx, incy, n
! .. Array Arguments ..
          Real (wp) :: sx(*), sy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
! .. Function Return Value ..
          Real (wp) :: sdsdot
        End Function sdsdot
        Subroutine sgbmv(trans, m, n, kl, ku, alpha, a, lda, x, incx, beta, y, &
          incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: incx, incy, kl, ku, lda, m, n
          Character (1) :: trans
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine sgbmv
        Subroutine sgemm(transa, transb, m, n, k, alpha, a, lda, b, ldb, beta, &
          c, ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: k, lda, ldb, ldc, m, n
          Character (1) :: transa, transb
! .. Array Arguments ..
          Real (wp) :: a(lda, *), b(ldb, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine sgemm
        Subroutine sgemmt(uplo, transa, transb, n, k, alpha, a, lda, b, ldb, beta, &
          c, ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: n, k, lda, ldb, ldc
          Character (1) :: uplo, transa, transb
! .. Array Arguments ..
          Real (wp) :: a(lda, *), b(ldb, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine sgemmt
        Subroutine sgemv(trans, m, n, alpha, a, lda, x, incx, beta, y, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: incx, incy, lda, m, n
          Character (1) :: trans
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine sgemv
        Subroutine sger(m, n, alpha, x, incx, y, incy, a, lda)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: alpha
          Integer :: incx, incy, lda, m, n
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine sger
        Subroutine sgerb(m, n, alpha, x, incx, y, incy, beta, a, lda)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: incx, incy, lda, m, n
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine sgerb
        Function snrm2(n, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, n
! .. Array Arguments ..
          Real (wp) :: x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
! .. Function Return Value ..
          Real (wp) :: snrm2
        End Function snrm2
        Subroutine srot(n, sx, incx, sy, incy, c, s)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: c, s
          Integer :: incx, incy, n
! .. Array Arguments ..
          Real (wp) :: sx(*), sy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine srot
        Subroutine srotg(sa, sb, c, s)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: c, s, sa, sb
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine srotg
        Subroutine srotm(n, sx, incx, sy, incy, sparam)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, incy, n
! .. Array Arguments ..
          Real (wp) :: sparam(5), sx(*), sy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine srotm
        Subroutine srotmg(sd1, sd2, sx1, sy1, sparam)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: sd1, sd2, sx1, sy1
! .. Array Arguments ..
          Real (wp) :: sparam(5)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine srotmg
        Subroutine ssbmv(uplo, n, k, alpha, a, lda, x, incx, beta, y, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: incx, incy, k, lda, n
          Character (1) :: uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ssbmv
        Subroutine sscal(n, sa, sx, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: sa
          Integer :: incx, n
! .. Array Arguments ..
          Real (wp) :: sx(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine sscal
        Subroutine sspmv(uplo, n, alpha, ap, x, incx, beta, y, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: incx, incy, n
          Character (1) :: uplo
! .. Array Arguments ..
          Real (wp) :: ap(*), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine sspmv
        Subroutine sspr(uplo, n, alpha, x, incx, ap)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: alpha
          Integer :: incx, n
          Character (1) :: uplo
! .. Array Arguments ..
          Real (wp) :: ap(*), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine sspr
        Subroutine sspr2(uplo, n, alpha, x, incx, y, incy, ap)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: alpha
          Integer :: incx, incy, n
          Character (1) :: uplo
! .. Array Arguments ..
          Real (wp) :: ap(*), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine sspr2
        Subroutine sswap(n, sx, incx, sy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, incy, n
! .. Array Arguments ..
          Real (wp) :: sx(*), sy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine sswap
        Subroutine ssymm(side, uplo, m, n, alpha, a, lda, b, ldb, beta, c, &
          ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: lda, ldb, ldc, m, n
          Character (1) :: side, uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), b(ldb, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ssymm
        Subroutine ssymv(uplo, n, alpha, a, lda, x, incx, beta, y, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: incx, incy, lda, n
          Character (1) :: uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ssymv
        Subroutine ssyr(uplo, n, alpha, x, incx, a, lda)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: alpha
          Integer :: incx, lda, n
          Character (1) :: uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ssyr
        Subroutine ssyr2(uplo, n, alpha, x, incx, y, incy, a, lda)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: alpha
          Integer :: incx, incy, lda, n
          Character (1) :: uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ssyr2
        Subroutine ssyr2k(uplo, trans, n, k, alpha, a, lda, b, ldb, beta, c, &
          ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: k, lda, ldb, ldc, n
          Character (1) :: trans, uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), b(ldb, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ssyr2k
        Subroutine ssyrk(uplo, trans, n, k, alpha, a, lda, beta, c, ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: k, lda, ldc, n
          Character (1) :: trans, uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ssyrk
        Subroutine stbmv(uplo, trans, diag, n, k, a, lda, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, k, lda, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine stbmv
        Subroutine stbsv(uplo, trans, diag, n, k, a, lda, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, k, lda, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine stbsv
        Subroutine stpmv(uplo, trans, diag, n, ap, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Real (wp) :: ap(*), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine stpmv
        Subroutine stpsv(uplo, trans, diag, n, ap, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Real (wp) :: ap(*), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine stpsv
        Subroutine strmm(side, uplo, transa, diag, m, n, alpha, a, lda, b, &
          ldb)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: alpha
          Integer :: lda, ldb, m, n
          Character (1) :: diag, side, transa, uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), b(ldb, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine strmm
        Subroutine strmv(uplo, trans, diag, n, a, lda, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, lda, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine strmv
        Subroutine strsm(side, uplo, transa, diag, m, n, alpha, a, lda, b, &
          ldb)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: alpha
          Integer :: lda, ldb, m, n
          Character (1) :: diag, side, transa, uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), b(ldb, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine strsm
        Subroutine strsv(uplo, trans, diag, n, a, lda, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Integer :: incx, lda, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Real (wp) :: a(lda, *), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine strsv
        Subroutine xerbla(srname, info)
! .. Implicit None Statement ..
          Implicit None
! .. Scalar Arguments ..
          Integer :: info
          Character (*) :: srname
        End Subroutine xerbla
        Subroutine xerbla_array(srname_array, srname_len, info)
! .. Implicit None Statement ..
          Implicit None
! .. Scalar Arguments ..
          Integer :: info, srname_len
! .. Array Arguments ..
          Character (1) :: srname_array(srname_len)
        End Subroutine xerbla_array
        Subroutine zaxpy(n, za, zx, incx, zy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: za
          Integer :: incx, incy, n
! .. Array Arguments ..
          Complex (wp) :: zx(*), zy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zaxpy
        Subroutine zcopy(n, zx, incx, zy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, incy, n
! .. Array Arguments ..
          Complex (wp) :: zx(*), zy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zcopy
        Function zdotc(n, zx, incx, zy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, incy, n
! .. Array Arguments ..
          Complex (wp) :: zx(*), zy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
! .. Function Return Value ..
          Complex (wp) :: zdotc
        End Function zdotc
        Function zdotu(n, zx, incx, zy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, incy, n
! .. Array Arguments ..
          Complex (wp) :: zx(*), zy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
! .. Function Return Value ..
          Complex (wp) :: zdotu
        End Function zdotu
        Subroutine zdrot(n, cx, incx, cy, incy, c, s)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: c, s
          Integer :: incx, incy, n
! .. Array Arguments ..
          Complex (wp) :: cx(*), cy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zdrot
        Subroutine zdscal(n, da, zx, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: da
          Integer :: incx, n
! .. Array Arguments ..
          Complex (wp) :: zx(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zdscal
        Subroutine zgbmv(trans, m, n, kl, ku, alpha, a, lda, x, incx, beta, y, &
          incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: incx, incy, kl, ku, lda, m, n
          Character (1) :: trans
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zgbmv
        Subroutine zgemm(transa, transb, m, n, k, alpha, a, lda, b, ldb, beta, &
          c, ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: k, lda, ldb, ldc, m, n
          Character (1) :: transa, transb
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), b(ldb, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zgemm
        Subroutine zgemmt(uplo, transa, transb, n, k, alpha, a, lda, b, ldb, beta, &
          c, ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: n, k, lda, ldb, ldc
          Character (1) :: uplo, transa, transb
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), b(ldb, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zgemmt
        Subroutine zgemv(trans, m, n, alpha, a, lda, x, incx, beta, y, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: incx, incy, lda, m, n
          Character (1) :: trans
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zgemv
        Subroutine zgerbc(m, n, alpha, x, incx, y, incy, beta, a, lda)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: incx, incy, lda, m, n
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zgerbc
        Subroutine zgerbu(m, n, alpha, x, incx, y, incy, beta, a, lda)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: incx, incy, lda, m, n
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zgerbu
        Subroutine zgerc(m, n, alpha, x, incx, y, incy, a, lda)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha
          Integer :: incx, incy, lda, m, n
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zgerc
        Subroutine zgeru(m, n, alpha, x, incx, y, incy, a, lda)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha
          Integer :: incx, incy, lda, m, n
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zgeru
        Subroutine zhbmv(uplo, n, k, alpha, a, lda, x, incx, beta, y, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: incx, incy, k, lda, n
          Character (1) :: uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zhbmv
        Subroutine zhemm(side, uplo, m, n, alpha, a, lda, b, ldb, beta, c, &
          ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: lda, ldb, ldc, m, n
          Character (1) :: side, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), b(ldb, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zhemm
        Subroutine zhemv(uplo, n, alpha, a, lda, x, incx, beta, y, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: incx, incy, lda, n
          Character (1) :: uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zhemv
        Subroutine zher(uplo, n, alpha, x, incx, a, lda)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: alpha
          Integer :: incx, lda, n
          Character (1) :: uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zher
        Subroutine zher2(uplo, n, alpha, x, incx, y, incy, a, lda)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha
          Integer :: incx, incy, lda, n
          Character (1) :: uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zher2
        Subroutine zher2k(uplo, trans, n, k, alpha, a, lda, b, ldb, beta, c, &
          ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha
          Real (wp) :: beta
          Integer :: k, lda, ldb, ldc, n
          Character (1) :: trans, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), b(ldb, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zher2k
        Subroutine zherk(uplo, trans, n, k, alpha, a, lda, beta, c, ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: alpha, beta
          Integer :: k, lda, ldc, n
          Character (1) :: trans, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zherk
        Subroutine zhpmv(uplo, n, alpha, ap, x, incx, beta, y, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: incx, incy, n
          Character (1) :: uplo
! .. Array Arguments ..
          Complex (wp) :: ap(*), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zhpmv
        Subroutine zhpr(uplo, n, alpha, x, incx, ap)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Real (wp) :: alpha
          Integer :: incx, n
          Character (1) :: uplo
! .. Array Arguments ..
          Complex (wp) :: ap(*), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zhpr
        Subroutine zhpr2(uplo, n, alpha, x, incx, y, incy, ap)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha
          Integer :: incx, incy, n
          Character (1) :: uplo
! .. Array Arguments ..
          Complex (wp) :: ap(*), x(*), y(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zhpr2
        Subroutine zrotg(ca, cb, c, s)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: ca, cb, s
          Real (wp) :: c
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zrotg
        Subroutine zscal(n, za, zx, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: za
          Integer :: incx, n
! .. Array Arguments ..
          Complex (wp) :: zx(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zscal
        Subroutine zswap(n, zx, incx, zy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, incy, n
! .. Array Arguments ..
          Complex (wp) :: zx(*), zy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zswap
        Subroutine zsymm(side, uplo, m, n, alpha, a, lda, b, ldb, beta, c, &
          ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: lda, ldb, ldc, m, n
          Character (1) :: side, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), b(ldb, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zsymm
        Subroutine zsyr2k(uplo, trans, n, k, alpha, a, lda, b, ldb, beta, c, &
          ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: k, lda, ldb, ldc, n
          Character (1) :: trans, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), b(ldb, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zsyr2k
        Subroutine zsyrk(uplo, trans, n, k, alpha, a, lda, beta, c, ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: k, lda, ldc, n
          Character (1) :: trans, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zsyrk
        Subroutine ztbmv(uplo, trans, diag, n, k, a, lda, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, k, lda, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ztbmv
        Subroutine ztbsv(uplo, trans, diag, n, k, a, lda, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, k, lda, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ztbsv
        Subroutine ztpmv(uplo, trans, diag, n, ap, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Complex (wp) :: ap(*), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ztpmv
        Subroutine ztpsv(uplo, trans, diag, n, ap, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Complex (wp) :: ap(*), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ztpsv
        Subroutine ztrmm(side, uplo, transa, diag, m, n, alpha, a, lda, b, &
          ldb)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha
          Integer :: lda, ldb, m, n
          Character (1) :: diag, side, transa, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), b(ldb, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ztrmm
        Subroutine ztrmv(uplo, trans, diag, n, a, lda, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, lda, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ztrmv
        Subroutine ztrsm(side, uplo, transa, diag, m, n, alpha, a, lda, b, &
          ldb)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha
          Integer :: lda, ldb, m, n
          Character (1) :: diag, side, transa, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), b(ldb, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ztrsm
        Subroutine ztrsv(uplo, trans, diag, n, a, lda, x, incx)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Integer :: incx, lda, n
          Character (1) :: diag, trans, uplo
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), x(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine ztrsv
        Subroutine sgemm_batch(transa_array, transb_array, m_array, n_array, &
          k_array, alpha_array, a_array, lda_array, b_array, ldb_array, &
          beta_array, c_array, ldc_array, group_count, group_size)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
          Integer, Parameter :: i8 = selected_int_kind(10)
! .. Scalar Arguments ..
          Integer :: group_count
! .. Array Arguments ..
          Character (1) :: transa_array(*), transb_array(*)
          Integer :: m_array(*), n_array(*), k_array(*)
          Integer :: lda_array(*), ldb_array(*), ldc_array(*)
          Integer :: group_size(*)
          Integer(i8) :: a_array(*), b_array(*), c_array(*)
          Real (wp) :: alpha_array(*), beta_array(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind, selected_int_kind
        End Subroutine sgemm_batch
        Subroutine dgemm_batch(transa_array, transb_array, m_array, n_array, &
          k_array, alpha_array, a_array, lda_array, b_array, ldb_array, &
          beta_array, c_array, ldc_array, group_count, group_size)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.D0)
          Integer, Parameter :: i8 = selected_int_kind(10)
! .. Scalar Arguments ..
          Integer :: group_count
! .. Array Arguments ..
          Character (1) :: transa_array(*), transb_array(*)
          Integer :: m_array(*), n_array(*), k_array(*)
          Integer :: lda_array(*), ldb_array(*), ldc_array(*)
          Integer :: group_size(*)
          Integer(i8) :: a_array(*), b_array(*), c_array(*)
          Real (wp) :: alpha_array(*), beta_array(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind, selected_int_kind
        End Subroutine dgemm_batch
        Subroutine cgemm_batch(transa_array, transb_array, m_array, n_array, &
          k_array, alpha_array, a_array, lda_array, b_array, ldb_array, &
          beta_array, c_array, ldc_array, group_count, group_size)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
          Integer, Parameter :: i8 = selected_int_kind(10)
! .. Scalar Arguments ..
          Integer :: group_count
! .. Array Arguments ..
          Character (1) :: transa_array(*), transb_array(*)
          Integer :: m_array(*), n_array(*), k_array(*)
          Integer :: lda_array(*), ldb_array(*), ldc_array(*)
          Integer :: group_size(*)
          Integer(i8) :: a_array(*), b_array(*), c_array(*)
          Complex (wp) :: alpha_array(*), beta_array(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind, selected_int_kind
        End Subroutine cgemm_batch
        Subroutine zgemm_batch(transa_array, transb_array, m_array, n_array, &
          k_array, alpha_array, a_array, lda_array, b_array, ldb_array, &
          beta_array, c_array, ldc_array, group_count, group_size)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.D0)
          Integer, Parameter :: i8 = selected_int_kind(10)
! .. Scalar Arguments ..
          Integer :: group_count
! .. Array Arguments ..
          Character (1) :: transa_array(*), transb_array(*)
          Integer :: m_array(*), n_array(*), k_array(*)
          Integer :: lda_array(*), ldb_array(*), ldc_array(*)
          Integer :: group_size(*)
          Integer(i8) :: a_array(*), b_array(*), c_array(*)
          Complex (wp) :: alpha_array(*), beta_array(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind, selected_int_kind
        End Subroutine zgemm_batch
        Subroutine cgemm3m(transa, transb, m, n, k, alpha, a, lda, b, ldb, beta, &
          c, ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: k, lda, ldb, ldc, m, n
          Character (1) :: transa, transb
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), b(ldb, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine cgemm3m
        Subroutine zgemm3m(transa, transb, m, n, k, alpha, a, lda, b, ldb, beta, &
          c, ldc)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0D0)
! .. Scalar Arguments ..
          Complex (wp) :: alpha, beta
          Integer :: k, lda, ldb, ldc, m, n
          Character (1) :: transa, transb
! .. Array Arguments ..
          Complex (wp) :: a(lda, *), b(ldb, *), c(ldc, *)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zgemm3m
        Subroutine saxpby(n, sa, sx, incx, sb, sy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: sa, sb
          Integer :: incx, incy, n
! .. Array Arguments ..
          Real (wp) :: sx(*), sy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine saxpby
        Subroutine daxpby(n, sa, sx, incx, sb, sy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.D0)
! .. Scalar Arguments ..
          Real (wp) :: sa, sb
          Integer :: incx, incy, n
! .. Array Arguments ..
          Real (wp) :: sx(*), sy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine daxpby
        Subroutine caxpby(n, sa, sx, incx, sb, sy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: sa, sb
          Integer :: incx, incy, n
! .. Array Arguments ..
          Complex (wp) :: sx(*), sy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine caxpby
        Subroutine zaxpby(n, sa, sx, incx, sb, sy, incy)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.D0)
! .. Scalar Arguments ..
          Complex (wp) :: sa, sb
          Integer :: incx, incy, n
! .. Array Arguments ..
          Complex (wp) :: sx(*), sy(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zaxpby
        Subroutine swaxpby(n, sa, sx, incx, sb, sy, incy, sw, incw)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Real (wp) :: sa, sb
          Integer :: incx, incy, incw, n
! .. Array Arguments ..
          Real (wp) :: sx(*), sy(*), sw(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine swaxpby
        Subroutine dwaxpby(n, sa, sx, incx, sb, sy, incy, sw, incw)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.D0)
! .. Scalar Arguments ..
          Real (wp) :: sa, sb
          Integer :: incx, incy, incw, n
! .. Array Arguments ..
          Real (wp) :: sx(*), sy(*), sw(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine dwaxpby
        Subroutine cwaxpby(n, sa, sx, incx, sb, sy, incy, sw, incw)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.0)
! .. Scalar Arguments ..
          Complex (wp) :: sa, sb
          Integer :: incx, incy, incw, n
! .. Array Arguments ..
          Complex (wp) :: sx(*), sy(*), sw(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine cwaxpby
        Subroutine zwaxpby(n, sa, sx, incx, sb, sy, incy, sw, incw)
! .. Implicit None Statement ..
          Implicit None
! .. Parameters ..
          Integer, Parameter :: wp = kind(0.D0)
! .. Scalar Arguments ..
          Complex (wp) :: sa, sb
          Integer :: incx, incy, incw, n
! .. Array Arguments ..
          Complex (wp) :: sx(*), sy(*), sw(*)
! .. Intrinsic Procedures ..
          Intrinsic :: kind
        End Subroutine zwaxpby
      End Interface
    End Module armpl_blas

!
!   ARMPL version 21.0 Copyright ARM, NAG 2021
!
!   Parameters for Fortran sparse routines in ARMPL
!
module armpl_sparse_params
    use armpl_kinds
    implicit none

!   Fortran versions of C enums

    integer(kind=armpl_i4), parameter :: armpl_status_success = 0
    integer(kind=armpl_i4), parameter :: armpl_status_input_parameter_error = 1
    integer(kind=armpl_i4), parameter :: armpl_status_execution_failure = 2
    integer(kind=armpl_i4), parameter :: armpl_sparse_create_nocopy = 3

    integer(kind=armpl_i4), parameter :: armpl_sparse_hint_structure = 50
    integer(kind=armpl_i4), parameter :: armpl_sparse_hint_spmv_operation = 60
    integer(kind=armpl_i4), parameter :: armpl_sparse_hint_spmm_operation = 61
    integer(kind=armpl_i4), parameter :: armpl_sparse_hint_spadd_operation = 62
    integer(kind=armpl_i4), parameter :: armpl_sparse_hint_spmm_strategy = 63
    integer(kind=armpl_i4), parameter :: armpl_sparse_hint_memory = 70
    integer(kind=armpl_i4), parameter :: armpl_sparse_hint_spmv_invocations = 80
    integer(kind=armpl_i4), parameter :: armpl_sparse_hint_spmm_invocations = 81
    integer(kind=armpl_i4), parameter :: armpl_sparse_hint_spadd_invocations = 82

    integer(kind=armpl_i4), parameter :: armpl_col_major = 90
    integer(kind=armpl_i4), parameter :: armpl_row_major = 91

    integer(kind=armpl_i4), parameter :: armpl_sparse_structure_dense = 100
    integer(kind=armpl_i4), parameter :: armpl_sparse_structure_unstructured = 101
    integer(kind=armpl_i4), parameter :: armpl_sparse_structure_symmetric = 110
    integer(kind=armpl_i4), parameter :: armpl_sparse_structure_diagonal = 120
    integer(kind=armpl_i4), parameter :: armpl_sparse_structure_blockdiagonal = 130
    integer(kind=armpl_i4), parameter :: armpl_sparse_structure_banded = 140
    integer(kind=armpl_i4), parameter :: armpl_sparse_structure_triangular = 150
    integer(kind=armpl_i4), parameter :: armpl_sparse_structure_blocktriangular = 160
    integer(kind=armpl_i4), parameter :: armpl_sparse_structure_hermitian = 170
    integer(kind=armpl_i4), parameter :: armpl_sparse_structure_hpcg = 180

    integer(kind=armpl_i4), parameter :: armpl_sparse_memory_noallocs = 200
    integer(kind=armpl_i4), parameter :: armpl_sparse_memory_allocs = 201

    integer(kind=armpl_i4), parameter :: armpl_sparse_operation_notrans = 300
    integer(kind=armpl_i4), parameter :: armpl_sparse_operation_trans = 310
    integer(kind=armpl_i4), parameter :: armpl_sparse_operation_conjtrans = 320

    integer(kind=armpl_i4), parameter :: armpl_sparse_invocations_single = 400
    integer(kind=armpl_i4), parameter :: armpl_sparse_invocations_few = 410
    integer(kind=armpl_i4), parameter :: armpl_sparse_invocations_many = 420

    integer(kind=armpl_i4), parameter :: armpl_sparse_scalar_one = 500
    integer(kind=armpl_i4), parameter :: armpl_sparse_scalar_zero = 501
    integer(kind=armpl_i4), parameter :: armpl_sparse_scalar_any = 502

    integer(kind=armpl_i4), parameter :: armpl_sparse_spmm_strat_unset = 600
    integer(kind=armpl_i4), parameter :: armpl_sparse_spmm_strat_opt_no_struct = 601
    integer(kind=armpl_i4), parameter :: armpl_sparse_spmm_strat_opt_part_struct = 602
    integer(kind=armpl_i4), parameter :: armpl_sparse_spmm_strat_opt_full_struct = 603

end module armpl_sparse_params

!
!  ARMPL version 21.0 Copyright ARM, NAG 2021
!
module armpl_kinds

integer, parameter :: armpl_i4 = selected_int_kind(8)
integer, parameter :: armpl_i8 = selected_int_kind(10)
integer, parameter :: armpl_r32 = selected_real_kind(6, 37)
integer, parameter :: armpl_r64 = selected_real_kind(15, 307)

end module armpl_kinds

!
!   ARMPL version 21.0 Copyright ARM, NAG 2021
!
!   Interface blocks for Fortran sparse routines in ARMPL
!
module armpl_sparse

    use armpl_kinds
    use armpl_sparse_params

!   Sparse matrix utility subroutines

    interface armpl_spmat_create_csr

        subroutine armpl_spmat_create_csr_s(A, m, n, row_ptr, col_indx, vals, flags, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(out) :: A
            integer, intent(in) :: m, n
            integer, intent(in) :: row_ptr(m+1)
            integer, intent(in) :: col_indx(*)
            real(kind=armpl_r32), intent(in) :: vals(*)
            integer, intent(in) :: flags
            integer, intent(out) :: info
        end subroutine armpl_spmat_create_csr_s

        subroutine armpl_spmat_create_csr_d(A, m, n, row_ptr, col_indx, vals, flags, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(out) :: A
            integer, intent(in) :: m, n
            integer, intent(in) :: row_ptr(m+1)
            integer, intent(in) :: col_indx(*)
            real(kind=armpl_r64), intent(in) :: vals(*)
            integer, intent(in) :: flags
            integer, intent(out) :: info
        end subroutine armpl_spmat_create_csr_d

        subroutine armpl_spmat_create_csr_c(A, m, n, row_ptr, col_indx, vals, flags, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(out) :: A
            integer, intent(in) :: m, n
            integer, intent(in) :: row_ptr(m+1)
            integer, intent(in) :: col_indx(*)
            complex(kind=armpl_r32), intent(in) :: vals(*)
            integer, intent(in) :: flags
            integer, intent(out) :: info
        end subroutine armpl_spmat_create_csr_c

        subroutine armpl_spmat_create_csr_z(A, m, n, row_ptr, col_indx, vals, flags, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(out) :: A
            integer, intent(in) :: m, n
            integer, intent(in) :: row_ptr(m+1)
            integer, intent(in) :: col_indx(*)
            complex(kind=armpl_r64), intent(in) :: vals(*)
            integer, intent(in) :: flags
            integer, intent(out) :: info
        end subroutine armpl_spmat_create_csr_z

    end interface armpl_spmat_create_csr

    interface armpl_spmat_create_csc

        subroutine armpl_spmat_create_csc_s(A, m, n, row_indx, col_ptr, vals, flags, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(out) :: A
            integer, intent(in) :: m, n
            integer, intent(in) :: row_indx(*)
            integer, intent(in) :: col_ptr(n+1)
            real(kind=armpl_r32), intent(in) :: vals(*)
            integer, intent(in) :: flags
            integer, intent(out) :: info
        end subroutine armpl_spmat_create_csc_s

        subroutine armpl_spmat_create_csc_d(A, m, n, row_indx, col_ptr, vals, flags, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(out) :: A
            integer, intent(in) :: m, n
            integer, intent(in) :: row_indx(*)
            integer, intent(in) :: col_ptr(n+1)
            real(kind=armpl_r64), intent(in) :: vals(*)
            integer, intent(in) :: flags
            integer, intent(out) :: info
        end subroutine armpl_spmat_create_csc_d

        subroutine armpl_spmat_create_csc_c(A, m, n, row_indx, col_ptr, vals, flags, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(out) :: A
            integer, intent(in) :: m, n
            integer, intent(in) :: row_indx(*)
            integer, intent(in) :: col_ptr(n+1)
            complex(kind=armpl_r32), intent(in) :: vals(*)
            integer, intent(in) :: flags
            integer, intent(out) :: info
        end subroutine armpl_spmat_create_csc_c

        subroutine armpl_spmat_create_csc_z(A, m, n, row_indx, col_ptr, vals, flags, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(out) :: A
            integer, intent(in) :: m, n
            integer, intent(in) :: row_indx(*)
            integer, intent(in) :: col_ptr(n+1)
            complex(kind=armpl_r64), intent(in) :: vals(*)
            integer, intent(in) :: flags
            integer, intent(out) :: info
        end subroutine armpl_spmat_create_csc_z

    end interface armpl_spmat_create_csc

    interface armpl_spmat_create_coo

        subroutine armpl_spmat_create_coo_s(A, m, n, nnz, row_indx, col_indx, vals, flags, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(out) :: A
            integer, intent(in) :: m, n, nnz
            integer, intent(in) :: row_indx(*)
            integer, intent(in) :: col_indx(*)
            real(kind=armpl_r32), intent(in) :: vals(*)
            integer, intent(in) :: flags
            integer, intent(out) :: info
        end subroutine armpl_spmat_create_coo_s

        subroutine armpl_spmat_create_coo_d(A, m, n, nnz, row_indx, col_indx, vals, flags, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(out) :: A
            integer, intent(in) :: m, n, nnz
            integer, intent(in) :: row_indx(*)
            integer, intent(in) :: col_indx(*)
            real(kind=armpl_r64), intent(in) :: vals(*)
            integer, intent(in) :: flags
            integer, intent(out) :: info
        end subroutine armpl_spmat_create_coo_d

        subroutine armpl_spmat_create_coo_c(A, m, n, nnz, row_indx, col_indx, vals, flags, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(out) :: A
            integer, intent(in) :: m, n, nnz
            integer, intent(in) :: row_indx(*)
            integer, intent(in) :: col_indx(*)
            complex(kind=armpl_r32), intent(in) :: vals(*)
            integer, intent(in) :: flags
            integer, intent(out) :: info
        end subroutine armpl_spmat_create_coo_c

        subroutine armpl_spmat_create_coo_z(A, m, n, nnz, row_indx, col_indx, vals, flags, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(out) :: A
            integer, intent(in) :: m, n, nnz
            integer, intent(in) :: row_indx(*)
            integer, intent(in) :: col_indx(*)
            complex(kind=armpl_r64), intent(in) :: vals(*)
            integer, intent(in) :: flags
            integer, intent(out) :: info
        end subroutine armpl_spmat_create_coo_z

    end interface armpl_spmat_create_coo

    interface
        subroutine armpl_spmat_destroy(A, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(inout) :: A
            integer, intent(out) :: info
        end subroutine armpl_spmat_destroy
    end interface

    interface
        subroutine armpl_spmat_hint(A, sparse_hint_type, sparse_hint_value, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer(kind=armpl_i4), intent(in) :: sparse_hint_type, sparse_hint_value
            integer, intent(out) :: info
        end subroutine armpl_spmat_hint
    end interface

    interface
        subroutine armpl_spmv_optimize(A, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer, intent(out) :: info
        end subroutine armpl_spmv_optimize
    end interface

    interface armpl_spmat_update

        subroutine armpl_spmat_update_s(A, n_updates, row_indx, col_indx, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer, intent(in) :: n_updates
            integer, intent(in) :: row_indx(n_updates)
            integer, intent(in) :: col_indx(n_updates)
            real(kind=armpl_r32), intent(in) :: vals(n_updates)
            integer, intent(out) :: info
        end subroutine armpl_spmat_update_s

        subroutine armpl_spmat_update_d(A, n_updates, row_indx, col_indx, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer, intent(in) :: n_updates
            integer, intent(in) :: row_indx(n_updates)
            integer, intent(in) :: col_indx(n_updates)
            real(kind=armpl_r64), intent(in) :: vals(n_updates)
            integer, intent(out) :: info
        end subroutine armpl_spmat_update_d

        subroutine armpl_spmat_update_c(A, n_updates, row_indx, col_indx, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer, intent(in) :: n_updates
            integer, intent(in) :: row_indx(n_updates)
            integer, intent(in) :: col_indx(n_updates)
            complex(kind=armpl_r32), intent(in) :: vals(n_updates)
            integer, intent(out) :: info
        end subroutine armpl_spmat_update_c

        subroutine armpl_spmat_update_z(A, n_updates, row_indx, col_indx, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer, intent(in) :: n_updates
            integer, intent(in) :: row_indx(n_updates)
            integer, intent(in) :: col_indx(n_updates)
            complex(kind=armpl_r64), intent(in) :: vals(n_updates)
            integer, intent(out) :: info
        end subroutine armpl_spmat_update_z

    end interface armpl_spmat_update

    interface armpl_spmat_create_dense

        subroutine armpl_spmat_create_dense_s(A, layout, m, n, lda, vals, flags, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(out) :: A
            integer(kind=armpl_i4), intent(in) :: layout
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: lda
            real(kind=armpl_r32), intent(in) :: vals(*)
            integer, intent(in) :: flags
            integer, intent(out) :: info
        end subroutine armpl_spmat_create_dense_s

        subroutine armpl_spmat_create_dense_d(A, layout, m, n, lda, vals, flags, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(out) :: A
            integer(kind=armpl_i4), intent(in) :: layout
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: lda
            real(kind=armpl_r64), intent(in) :: vals(*)
            integer, intent(in) :: flags
            integer, intent(out) :: info
        end subroutine armpl_spmat_create_dense_d

        subroutine armpl_spmat_create_dense_c(A, layout, m, n, lda, vals, flags, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(out) :: A
            integer(kind=armpl_i4), intent(in) :: layout
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: lda
            complex(kind=armpl_r32), intent(in) :: vals(*)
            integer, intent(in) :: flags
            integer, intent(out) :: info
        end subroutine armpl_spmat_create_dense_c

        subroutine armpl_spmat_create_dense_z(A, layout, m, n, lda, vals, flags, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(out) :: A
            integer(kind=armpl_i4), intent(in) :: layout
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: lda
            complex(kind=armpl_r64), intent(in) :: vals(*)
            integer, intent(in) :: flags
            integer, intent(out) :: info
        end subroutine armpl_spmat_create_dense_z

    end interface armpl_spmat_create_dense

    interface armpl_spmat_create_bsr

        subroutine armpl_spmat_create_bsr_s(A, block_layout, m, n, block_size, row_ptr, col_indx, vals, flags, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(out) :: A
            integer(kind=armpl_i4), intent(in) :: block_layout
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: block_size
            integer, intent(in) :: row_ptr(*)
            integer, intent(in) :: col_indx(*)
            real(kind=armpl_r32), intent(in) :: vals(*)
            integer, intent(in) :: flags
            integer, intent(out) :: info
        end subroutine armpl_spmat_create_bsr_s

        subroutine armpl_spmat_create_bsr_d(A, block_layout, m, n, block_size, row_ptr, col_indx, vals, flags, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(out) :: A
            integer(kind=armpl_i4), intent(in) :: block_layout
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: block_size
            integer, intent(in) :: row_ptr(*)
            integer, intent(in) :: col_indx(*)
            real(kind=armpl_r64), intent(in) :: vals(*)
            integer, intent(in) :: flags
            integer, intent(out) :: info
        end subroutine armpl_spmat_create_bsr_d

        subroutine armpl_spmat_create_bsr_c(A, block_layout, m, n, block_size, row_ptr, col_indx, vals, flags, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(out) :: A
            integer(kind=armpl_i4), intent(in) :: block_layout
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: block_size
            integer, intent(in) :: row_ptr(*)
            integer, intent(in) :: col_indx(*)
            complex(kind=armpl_r32), intent(in) :: vals(*)
            integer, intent(in) :: flags
            integer, intent(out) :: info
        end subroutine armpl_spmat_create_bsr_c

        subroutine armpl_spmat_create_bsr_z(A, block_layout, m, n, block_size, row_ptr, col_indx, vals, flags, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(out) :: A
            integer(kind=armpl_i4), intent(in) :: block_layout
            integer, intent(in) :: m
            integer, intent(in) :: n
            integer, intent(in) :: block_size
            integer, intent(in) :: row_ptr(*)
            integer, intent(in) :: col_indx(*)
            complex(kind=armpl_r64), intent(in) :: vals(*)
            integer, intent(in) :: flags
            integer, intent(out) :: info
        end subroutine armpl_spmat_create_bsr_z

    end interface armpl_spmat_create_bsr

    interface
        function armpl_spmat_create_null(m, n)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8) :: armpl_spmat_create_null
            integer, intent(in) :: m
            integer, intent(in) :: n
        end function armpl_spmat_create_null
    end interface

    interface
        function armpl_spmat_create_identity(n)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8) :: armpl_spmat_create_identity
            integer, intent(in) :: n
        end function armpl_spmat_create_identity
    end interface

    interface
        subroutine armpl_spmat_query(A, m, n, nnz, base_index, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer, intent(out) :: m
            integer, intent(out) :: n
            integer, intent(out) :: nnz
            integer, intent(out) :: base_index
            integer, intent(out) :: info
        end subroutine armpl_spmat_query
    end interface

    interface
        subroutine armpl_spmm_optimize(transA, transB, alpha, A, B, beta, C, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i4), intent(in) :: transA
            integer(kind=armpl_i4), intent(in) :: transB
            integer(kind=armpl_i4), intent(in) :: alpha
            integer(kind=armpl_i8), intent(in) :: A
            integer(kind=armpl_i8), intent(in) :: B
            integer(kind=armpl_i4), intent(in) :: beta
            integer(kind=armpl_i8), intent(out) :: C
            integer, intent(out) :: info
        end subroutine armpl_spmm_optimize
    end interface

    interface
        subroutine armpl_spadd_optimize(transA, transB, alpha, A, beta, B, C, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i4), intent(in) :: transA
            integer(kind=armpl_i4), intent(in) :: transB
            integer(kind=armpl_i4), intent(in) :: alpha
            integer(kind=armpl_i8), intent(in) :: A
            integer(kind=armpl_i4), intent(in) :: beta
            integer(kind=armpl_i8), intent(in) :: B
            integer(kind=armpl_i8), intent(out) :: C
            integer, intent(out) :: info
        end subroutine armpl_spadd_optimize
    end interface

!   Sparse matrix--vector execution subroutines

    interface armpl_spmv_exec

        subroutine armpl_spmv_exec_s(trans, alpha, A, x, beta, y, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i4), intent(in) :: trans
            real(kind=armpl_r32), intent(in) :: alpha
            integer(kind=armpl_i8), intent(in) :: A
            real(kind=armpl_r32), intent(in) :: x(*)
            real(kind=armpl_r32), intent(in) :: beta
            real(kind=armpl_r32), intent(inout) :: y(*)
            integer, intent(out) :: info
        end subroutine armpl_spmv_exec_s

        subroutine armpl_spmv_exec_d(trans, alpha, A, x, beta, y, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i4), intent(in) :: trans
            real(kind=armpl_r64), intent(in) :: alpha
            integer(kind=armpl_i8), intent(in) :: A
            real(kind=armpl_r64), intent(in) :: x(*)
            real(kind=armpl_r64), intent(in) :: beta
            real(kind=armpl_r64), intent(inout) :: y(*)
            integer, intent(out) :: info
        end subroutine armpl_spmv_exec_d

        subroutine armpl_spmv_exec_c(trans, alpha, A, x, beta, y, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i4), intent(in) :: trans
            complex(kind=armpl_r32), intent(in) :: alpha
            integer(kind=armpl_i8), intent(in) :: A
            complex(kind=armpl_r32), intent(in) :: x(*)
            complex(kind=armpl_r32), intent(in) :: beta
            complex(kind=armpl_r32), intent(inout) :: y(*)
            integer, intent(out) :: info
        end subroutine armpl_spmv_exec_c

        subroutine armpl_spmv_exec_z(trans, alpha, A, x, beta, y, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i4), intent(in) :: trans
            complex(kind=armpl_r64), intent(in) :: alpha
            integer(kind=armpl_i8), intent(in) :: A
            complex(kind=armpl_r64), intent(in) :: x(*)
            complex(kind=armpl_r64), intent(in) :: beta
            complex(kind=armpl_r64), intent(inout) :: y(*)
            integer, intent(out) :: info
        end subroutine armpl_spmv_exec_z

    end interface armpl_spmv_exec

!   Sparse matrix--matrix execution subroutines

    interface armpl_spmm_exec

        subroutine armpl_spmm_exec_s(transA, transB, alpha, A, B, beta, C, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i4), intent(in) :: transA
            integer(kind=armpl_i4), intent(in) :: transB
            real(kind=armpl_r32), intent(in) :: alpha
            integer(kind=armpl_i8), intent(in) :: A
            integer(kind=armpl_i8), intent(in) :: B
            real(kind=armpl_r32), intent(in) :: beta
            integer(kind=armpl_i8), intent(out) :: C
            integer, intent(out) :: info
        end subroutine armpl_spmm_exec_s

        subroutine armpl_spmm_exec_d(transA, transB, alpha, A, B, beta, C, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i4), intent(in) :: transA
            integer(kind=armpl_i4), intent(in) :: transB
            real(kind=armpl_r64), intent(in) :: alpha
            integer(kind=armpl_i8), intent(in) :: A
            integer(kind=armpl_i8), intent(in) :: B
            real(kind=armpl_r64), intent(in) :: beta
            integer(kind=armpl_i8), intent(out) :: C
            integer, intent(out) :: info
        end subroutine armpl_spmm_exec_d

        subroutine armpl_spmm_exec_c(transA, transB, alpha, A, B, beta, C, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i4), intent(in) :: transA
            integer(kind=armpl_i4), intent(in) :: transB
            complex(kind=armpl_r32), intent(in) :: alpha
            integer(kind=armpl_i8), intent(in) :: A
            integer(kind=armpl_i8), intent(in) :: B
            complex(kind=armpl_r32), intent(in) :: beta
            integer(kind=armpl_i8), intent(out) :: C
            integer, intent(out) :: info
        end subroutine armpl_spmm_exec_c

        subroutine armpl_spmm_exec_z(transA, transB, alpha, A, B, beta, C, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i4), intent(in) :: transA
            integer(kind=armpl_i4), intent(in) :: transB
            complex(kind=armpl_r64), intent(in) :: alpha
            integer(kind=armpl_i8), intent(in) :: A
            integer(kind=armpl_i8), intent(in) :: B
            complex(kind=armpl_r64), intent(in) :: beta
            integer(kind=armpl_i8), intent(out) :: C
            integer, intent(out) :: info
        end subroutine armpl_spmm_exec_z

    end interface armpl_spmm_exec

    interface armpl_spadd_exec

        subroutine armpl_spadd_exec_s(transA, transB, alpha, A, beta, B, C, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i4), intent(in) :: transA
            integer(kind=armpl_i4), intent(in) :: transB
            real(kind=armpl_r32), intent(in) :: alpha
            integer(kind=armpl_i8), intent(in) :: A
            real(kind=armpl_r32), intent(in) :: beta
            integer(kind=armpl_i8), intent(in) :: B
            integer(kind=armpl_i8), intent(out) :: C
            integer, intent(out) :: info
        end subroutine armpl_spadd_exec_s

        subroutine armpl_spadd_exec_d(transA, transB, alpha, A, beta, B, C, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i4), intent(in) :: transA
            integer(kind=armpl_i4), intent(in) :: transB
            real(kind=armpl_r64), intent(in) :: alpha
            integer(kind=armpl_i8), intent(in) :: A
            real(kind=armpl_r64), intent(in) :: beta
            integer(kind=armpl_i8), intent(in) :: B
            integer(kind=armpl_i8), intent(out) :: C
            integer, intent(out) :: info
        end subroutine armpl_spadd_exec_d

        subroutine armpl_spadd_exec_c(transA, transB, alpha, A, beta, B, C, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i4), intent(in) :: transA
            integer(kind=armpl_i4), intent(in) :: transB
            complex(kind=armpl_r32), intent(in) :: alpha
            integer(kind=armpl_i8), intent(in) :: A
            complex(kind=armpl_r32), intent(in) :: beta
            integer(kind=armpl_i8), intent(in) :: B
            integer(kind=armpl_i8), intent(out) :: C
            integer, intent(out) :: info
        end subroutine armpl_spadd_exec_c

        subroutine armpl_spadd_exec_z(transA, transB, alpha, A, beta, B, C, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i4), intent(in) :: transA
            integer(kind=armpl_i4), intent(in) :: transB
            complex(kind=armpl_r64), intent(in) :: alpha
            integer(kind=armpl_i8), intent(in) :: A
            complex(kind=armpl_r64), intent(in) :: beta
            integer(kind=armpl_i8), intent(in) :: B
            integer(kind=armpl_i8), intent(out) :: C
            integer, intent(out) :: info
        end subroutine armpl_spadd_exec_z

    end interface armpl_spadd_exec

!   Sparse matrix export subroutines

    interface armpl_spmat_export_csr

        subroutine armpl_spmat_export_csr_s(A, index_base, m, n, row_ptr, col_indx, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer, intent(in) :: index_base
            integer, intent(out) :: m
            integer, intent(out) :: n
            integer, allocatable, intent(out) :: row_ptr(:)
            integer, allocatable, intent(out) :: col_indx(:)
            real(kind=armpl_r32), allocatable, intent(out) :: vals(:)
            integer, intent(out) :: info
        end subroutine armpl_spmat_export_csr_s

        subroutine armpl_spmat_export_csr_d(A, index_base, m, n, row_ptr, col_indx, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer, intent(in) :: index_base
            integer, intent(out) :: m
            integer, intent(out) :: n
            integer, allocatable, intent(out) :: row_ptr(:)
            integer, allocatable, intent(out) :: col_indx(:)
            real(kind=armpl_r64), allocatable, intent(out) :: vals(:)
            integer, intent(out) :: info
        end subroutine armpl_spmat_export_csr_d

        subroutine armpl_spmat_export_csr_c(A, index_base, m, n, row_ptr, col_indx, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer, intent(in) :: index_base
            integer, intent(out) :: m
            integer, intent(out) :: n
            integer, allocatable, intent(out) :: row_ptr(:)
            integer, allocatable, intent(out) :: col_indx(:)
            complex(kind=armpl_r32), allocatable, intent(out) :: vals(:)
            integer, intent(out) :: info
        end subroutine armpl_spmat_export_csr_c

        subroutine armpl_spmat_export_csr_z(A, index_base, m, n, row_ptr, col_indx, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer, intent(in) :: index_base
            integer, intent(out) :: m
            integer, intent(out) :: n
            integer, allocatable, intent(out) :: row_ptr(:)
            integer, allocatable, intent(out) :: col_indx(:)
            complex(kind=armpl_r64), allocatable, intent(out) :: vals(:)
            integer, intent(out) :: info
        end subroutine armpl_spmat_export_csr_z

    end interface armpl_spmat_export_csr

    interface armpl_spmat_export_csc

        subroutine armpl_spmat_export_csc_s(A, index_base, m, n, row_indx, col_ptr, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer, intent(in) :: index_base
            integer, intent(out) :: m
            integer, intent(out) :: n
            integer, allocatable, intent(out) :: row_indx(:)
            integer, allocatable, intent(out) :: col_ptr(:)
            real(kind=armpl_r32), allocatable, intent(out) :: vals(:)
            integer, intent(out) :: info
        end subroutine armpl_spmat_export_csc_s

        subroutine armpl_spmat_export_csc_d(A, index_base, m, n, row_indx, col_ptr, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer, intent(in) :: index_base
            integer, intent(out) :: m
            integer, intent(out) :: n
            integer, allocatable, intent(out) :: row_indx(:)
            integer, allocatable, intent(out) :: col_ptr(:)
            real(kind=armpl_r64), allocatable, intent(out) :: vals(:)
            integer, intent(out) :: info
        end subroutine armpl_spmat_export_csc_d

        subroutine armpl_spmat_export_csc_c(A, index_base, m, n, row_indx, col_ptr, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer, intent(in) :: index_base
            integer, intent(out) :: m
            integer, intent(out) :: n
            integer, allocatable, intent(out) :: row_indx(:)
            integer, allocatable, intent(out) :: col_ptr(:)
            complex(kind=armpl_r32), allocatable, intent(out) :: vals(:)
            integer, intent(out) :: info
        end subroutine armpl_spmat_export_csc_c

        subroutine armpl_spmat_export_csc_z(A, index_base, m, n, row_indx, col_ptr, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer, intent(in) :: index_base
            integer, intent(out) :: m
            integer, intent(out) :: n
            integer, allocatable, intent(out) :: row_indx(:)
            integer, allocatable, intent(out) :: col_ptr(:)
            complex(kind=armpl_r64), allocatable, intent(out) :: vals(:)
            integer, intent(out) :: info
        end subroutine armpl_spmat_export_csc_z

    end interface armpl_spmat_export_csc

    interface armpl_spmat_export_coo

        subroutine armpl_spmat_export_coo_s(A, m, n, nnz, row_indx, col_indx, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer, intent(out) :: m
            integer, intent(out) :: n
            integer, intent(out) :: nnz
            integer, allocatable, intent(out) :: row_indx(:)
            integer, allocatable, intent(out) :: col_indx(:)
            real(kind=armpl_r32), allocatable, intent(out) :: vals(:)
            integer, intent(out) :: info
        end subroutine armpl_spmat_export_coo_s

        subroutine armpl_spmat_export_coo_d(A, m, n, nnz, row_indx, col_indx, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer, intent(out) :: m
            integer, intent(out) :: n
            integer, intent(out) :: nnz
            integer, allocatable, intent(out) :: row_indx(:)
            integer, allocatable, intent(out) :: col_indx(:)
            real(kind=armpl_r64), allocatable, intent(out) :: vals(:)
            integer, intent(out) :: info
        end subroutine armpl_spmat_export_coo_d

        subroutine armpl_spmat_export_coo_c(A, m, n, nnz, row_indx, col_indx, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer, intent(out) :: m
            integer, intent(out) :: n
            integer, intent(out) :: nnz
            integer, allocatable, intent(out) :: row_indx(:)
            integer, allocatable, intent(out) :: col_indx(:)
            complex(kind=armpl_r32), allocatable, intent(out) :: vals(:)
            integer, intent(out) :: info
        end subroutine armpl_spmat_export_coo_c

        subroutine armpl_spmat_export_coo_z(A, m, n, nnz, row_indx, col_indx, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer, intent(out) :: m
            integer, intent(out) :: n
            integer, intent(out) :: nnz
            integer, allocatable, intent(out) :: row_indx(:)
            integer, allocatable, intent(out) :: col_indx(:)
            complex(kind=armpl_r64), allocatable, intent(out) :: vals(:)
            integer, intent(out) :: info
        end subroutine armpl_spmat_export_coo_z

    end interface armpl_spmat_export_coo

    interface armpl_spmat_export_dense

        subroutine armpl_spmat_export_dense_s(A, layout, m, n, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer(kind=armpl_i4), intent(in) :: layout
            integer, intent(out) :: m
            integer, intent(out) :: n
            real(kind=armpl_r32), allocatable, intent(out) :: vals(:)
            integer, intent(out) :: info
        end subroutine armpl_spmat_export_dense_s

        subroutine armpl_spmat_export_dense_d(A, layout, m, n, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer(kind=armpl_i4), intent(in) :: layout
            integer, intent(out) :: m
            integer, intent(out) :: n
            real(kind=armpl_r64), allocatable, intent(out) :: vals(:)
            integer, intent(out) :: info
        end subroutine armpl_spmat_export_dense_d

        subroutine armpl_spmat_export_dense_c(A, layout, m, n, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer(kind=armpl_i4), intent(in) :: layout
            integer, intent(out) :: m
            integer, intent(out) :: n
            complex(kind=armpl_r32), allocatable, intent(out) :: vals(:)
            integer, intent(out) :: info
        end subroutine armpl_spmat_export_dense_c

        subroutine armpl_spmat_export_dense_z(A, layout, m, n, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer(kind=armpl_i4), intent(in) :: layout
            integer, intent(out) :: m
            integer, intent(out) :: n
            complex(kind=armpl_r64), allocatable, intent(out) :: vals(:)
            integer, intent(out) :: info
        end subroutine armpl_spmat_export_dense_z

    end interface armpl_spmat_export_dense

    interface armpl_spmat_export_bsr

        subroutine armpl_spmat_export_bsr_s(A, block_layout, index_base, m, n, block_size, row_ptr, col_indx, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer(kind=armpl_i4), intent(in) :: block_layout
            integer, intent(in) :: index_base
            integer, intent(out) :: m
            integer, intent(out) :: n
            integer, intent(out) :: block_size
            integer, allocatable, intent(out) :: row_ptr(:)
            integer, allocatable, intent(out) :: col_indx(:)
            real(kind=armpl_r32), allocatable, intent(out) :: vals(:)
            integer, intent(out) :: info
        end subroutine armpl_spmat_export_bsr_s

        subroutine armpl_spmat_export_bsr_d(A, block_layout, index_base, m, n, block_size, row_ptr, col_indx, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer(kind=armpl_i4), intent(in) :: block_layout
            integer, intent(in) :: index_base
            integer, intent(out) :: m
            integer, intent(out) :: n
            integer, intent(out) :: block_size
            integer, allocatable, intent(out) :: row_ptr(:)
            integer, allocatable, intent(out) :: col_indx(:)
            real(kind=armpl_r64), allocatable, intent(out) :: vals(:)
            integer, intent(out) :: info
        end subroutine armpl_spmat_export_bsr_d

        subroutine armpl_spmat_export_bsr_c(A, block_layout, index_base, m, n, block_size, row_ptr, col_indx, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer(kind=armpl_i4), intent(in) :: block_layout
            integer, intent(in) :: index_base
            integer, intent(out) :: m
            integer, intent(out) :: n
            integer, intent(out) :: block_size
            integer, allocatable, intent(out) :: row_ptr(:)
            integer, allocatable, intent(out) :: col_indx(:)
            complex(kind=armpl_r32), allocatable, intent(out) :: vals(:)
            integer, intent(out) :: info
        end subroutine armpl_spmat_export_bsr_c

        subroutine armpl_spmat_export_bsr_z(A, block_layout, index_base, m, n, block_size, row_ptr, col_indx, vals, info)
            use armpl_kinds
            implicit none
            integer(kind=armpl_i8), intent(in) :: A
            integer(kind=armpl_i4), intent(in) :: block_layout
            integer, intent(in) :: index_base
            integer, intent(out) :: m
            integer, intent(out) :: n
            integer, intent(out) :: block_size
            integer, allocatable, intent(out) :: row_ptr(:)
            integer, allocatable, intent(out) :: col_indx(:)
            complex(kind=armpl_r64), allocatable, intent(out) :: vals(:)
            integer, intent(out) :: info
        end subroutine armpl_spmat_export_bsr_z

    end interface armpl_spmat_export_bsr

end module armpl_sparse

!
!   ARMPL version 21.0 Copyright ARM, NAG 2021
!
!   Interface blocks for Fortran routines in ARMPL
!
    Module armpl_library
!     .. Use Statements ..
      Use armpl_blas
      Use armpl_lapack
      Use armpl_sparse
!     .. Interface Blocks ..
      Interface
        Subroutine armplinfo
        End Subroutine armplinfo
        Subroutine armplversion(major, minor, patch)
!     .. Implicit None Statement ..
          Implicit None
!     .. Scalar Arguments ..
          Integer :: major, minor, patch
        End Subroutine armplversion
      End Interface
    End Module armpl_library

#!/usr/bin/env bash
# Run the tests for armpl

set -ex

exists() {
	FULL_PATH="${PREFIX}/${1}"
	if [ -f "${FULL_PATH}" ]; then
		echo "Found ${1}"
	else
		echo "Could not find ${FULL_PATH}"
		exit 1
	fi
}

for i in include/{armpl,blas,cblas,lapack,lapacke}.h lib/{libarmpl{,_mp,_int64_mp,_int64},libamath,libastring}.so; do
	exists $i
done

# Compile the example and run it
$CC -c -I"${PREFIX}/include" test/fftw_dft_r2c_1d_c_example.c -o fftw_dft_r2c_1d_c_example.o
$CC fftw_dft_r2c_1d_c_example.o -L"${PREFIX}/lib" -o fftw_dft_r2c_1d_c_example -larmpl_lp64 -lgfortran -lm
./fftw_dft_r2c_1d_c_example

#!/bin/bash
#
# Linux CLI Uninstaller
#
# Copyright 2015-2021 ARM Limited. All rights reserved.

set -eu -o pipefail

packages="armpl-21.0-gcc-10.2 arm-performance-libraries-21.0-gcc-10.2"

removal_command="rpm -e"
function in_use () { rpm --query --quiet --whatrequires $1; }

if [[ ${removal_command} == "dpkg -r" ]]; then
  dpkg_packages=""
  for package in $packages; do
    p="$(echo  "${package//_/-}" | tr '[:upper:]' '[:lower:]')"
    dpkg_packages="$dpkg_packages $p"
  done
  packages="$dpkg_packages"
fi

declare -r THIS_DIRECTORY=$( cd "$(dirname "${BASH_SOURCE[0]}")" > /dev/null 2>&1; pwd  -P)
declare -r INSTALLED_FILE_LIST="${THIS_DIRECTORY}/.installed_files"

if [[ ! -r $INSTALLED_FILE_LIST ]]; then
  if [[ $EUID -ne 0 ]]; then
    echo "You do not appear to be running as a privileged user."
    echo "Going ahead with the uninstall anyway..."
  fi
  to_process=$packages
  removed_one=1
  while [[ -n "$to_process" && $removed_one -eq 1 ]]; do
    packages="$to_process"
    to_process=""
    removed_one=0
    for package in $packages; do
      if [[ $package =~ ^gcc  && $packages == " $package" ]]; then
        if in_use "$package"; then
          echo "In use by other packages: $package"
          break
        fi
      fi
      if $removal_command "$package"  > /dev/null 2>&1; then
        removed_one=1
        echo "Uninstalled $package"
      else
        to_process="$to_process $package"
      fi
    done
  done
  if [[ -n "$to_process" ]]; then
    echo "Unable to uninstall the following packages:"
    for package in $to_process; do
      echo "  $package";
    done
    # Show the user why things failed to uninstall
    $removal_command $to_process
  fi
else
  # Uninstall by removing everything in INSTALLED_FILE_LIST
  suite_dir=$(basename "${THIS_DIRECTORY}")
  echo "Removing installed files..."
  for item in $(sort -r "$INSTALLED_FILE_LIST"); do
    if [[  $item =~ ^${suite_dir}$ ]]; then
      continue
    fi
    item="${THIS_DIRECTORY}/../${item}"
    if [[ -f $item || -h $item ]]; then
      rm "$item"
    elif [[ -d $item ]]; then
      if [[ -z $(ls -A "$item") ]]; then
        rmdir "$item"
      else
        echo "warning: non-empty directory $item"
      fi
    else
      if [[ -e $item ]]; then
        echo "warning: unrecognized file type for $item"
      else
        echo "warning: file already removed $item"
      fi
    fi
  done
  rm "$INSTALLED_FILE_LIST"
  rmdir "$THIS_DIRECTORY"
fi

# Repack the armpl binaries.
cd armpl
tar -xvf arm-performance-libraries_21.0_RHEL-7_gcc-10.2.tar?revision=df0303bf-296f-4f67-a4bf-344a05563bf4
cd arm-performance-libraries_21.0_RHEL-7_gcc-10.2
./arm-performance-libraries_21.0_*.sh --accept --install-to $PREFIX --force
mkdir $PREFIX/include
mkdir $PREFIX/lib
cp -rn $PREFIX/armpl_21.0_gcc-10.2/include*/* $PREFIX/include
cp -rn $PREFIX/armpl_21.0_gcc-10.2/lib*/* $PREFIX/lib
rm -rf $PREFIX/armpl_21.0_gcc-10.2
